<?php
/*
    Plugin Name: Download Monitor - Amazon S3
    Plugin URI: https://www.download-monitor.com/extensions/amazon-s3/
    Description: Lets you link to files hosted on Amazon s3 so that you can serve secure, expiring download links.
    Version: 4.0.2
    Author: Never5
    Author URI: http://www.never5.com
    License: GPL v2

	Copyright 2018 - Never5

	License: GNU General Public License v2.0
	License URI: http://www.gnu.org/licenses/gpl-2.0.html

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


if ( ! defined( 'ABSPATH' ) ) {
	header( 'Status: 403 Forbidden' );
	header( 'HTTP/1.1 403 Forbidden' );
	exit;
}

function __load_dlm_amazon_s3() {
	new \Never5\DownloadMonitor\AmazonS3\Plugin( '4.0.2' );
}

require_once 'vendor/wpupdatephp/wp-update-php/src/WPUpdatePhp.php';

// check PHP version
$updatePhp = new WPUpdatePhp( '5.5.0' );
if ( $updatePhp->does_it_meet_required_php_version( PHP_VERSION ) ) {

	// autoloader
	require 'vendor/autoload.php';

	define( 'DLM_AS3_FILE', __FILE__ );

	// create plugin object
	add_action( 'plugins_loaded', '__load_dlm_amazon_s3', 30 );
}