<?php
namespace Never5\Aws\OpsWorks;

use Never5\Aws\AwsClient;

/**
 * This client is used to interact with the **AWS OpsWorks** service.
 *
 * @method \Never5\Aws\Result assignInstance(array $args = [])
 * @method \GuzzleHttp\Promise\Promise assignInstanceAsync(array $args = [])
 * @method \Never5\Aws\Result assignVolume(array $args = [])
 * @method \GuzzleHttp\Promise\Promise assignVolumeAsync(array $args = [])
 * @method \Never5\Aws\Result associateElasticIp(array $args = [])
 * @method \GuzzleHttp\Promise\Promise associateElasticIpAsync(array $args = [])
 * @method \Never5\Aws\Result attachElasticLoadBalancer(array $args = [])
 * @method \GuzzleHttp\Promise\Promise attachElasticLoadBalancerAsync(array $args = [])
 * @method \Never5\Aws\Result cloneStack(array $args = [])
 * @method \GuzzleHttp\Promise\Promise cloneStackAsync(array $args = [])
 * @method \Never5\Aws\Result createApp(array $args = [])
 * @method \GuzzleHttp\Promise\Promise createAppAsync(array $args = [])
 * @method \Never5\Aws\Result createDeployment(array $args = [])
 * @method \GuzzleHttp\Promise\Promise createDeploymentAsync(array $args = [])
 * @method \Never5\Aws\Result createInstance(array $args = [])
 * @method \GuzzleHttp\Promise\Promise createInstanceAsync(array $args = [])
 * @method \Never5\Aws\Result createLayer(array $args = [])
 * @method \GuzzleHttp\Promise\Promise createLayerAsync(array $args = [])
 * @method \Never5\Aws\Result createStack(array $args = [])
 * @method \GuzzleHttp\Promise\Promise createStackAsync(array $args = [])
 * @method \Never5\Aws\Result createUserProfile(array $args = [])
 * @method \GuzzleHttp\Promise\Promise createUserProfileAsync(array $args = [])
 * @method \Never5\Aws\Result deleteApp(array $args = [])
 * @method \GuzzleHttp\Promise\Promise deleteAppAsync(array $args = [])
 * @method \Never5\Aws\Result deleteInstance(array $args = [])
 * @method \GuzzleHttp\Promise\Promise deleteInstanceAsync(array $args = [])
 * @method \Never5\Aws\Result deleteLayer(array $args = [])
 * @method \GuzzleHttp\Promise\Promise deleteLayerAsync(array $args = [])
 * @method \Never5\Aws\Result deleteStack(array $args = [])
 * @method \GuzzleHttp\Promise\Promise deleteStackAsync(array $args = [])
 * @method \Never5\Aws\Result deleteUserProfile(array $args = [])
 * @method \GuzzleHttp\Promise\Promise deleteUserProfileAsync(array $args = [])
 * @method \Never5\Aws\Result deregisterEcsCluster(array $args = [])
 * @method \GuzzleHttp\Promise\Promise deregisterEcsClusterAsync(array $args = [])
 * @method \Never5\Aws\Result deregisterElasticIp(array $args = [])
 * @method \GuzzleHttp\Promise\Promise deregisterElasticIpAsync(array $args = [])
 * @method \Never5\Aws\Result deregisterInstance(array $args = [])
 * @method \GuzzleHttp\Promise\Promise deregisterInstanceAsync(array $args = [])
 * @method \Never5\Aws\Result deregisterRdsDbInstance(array $args = [])
 * @method \GuzzleHttp\Promise\Promise deregisterRdsDbInstanceAsync(array $args = [])
 * @method \Never5\Aws\Result deregisterVolume(array $args = [])
 * @method \GuzzleHttp\Promise\Promise deregisterVolumeAsync(array $args = [])
 * @method \Never5\Aws\Result describeAgentVersions(array $args = [])
 * @method \GuzzleHttp\Promise\Promise describeAgentVersionsAsync(array $args = [])
 * @method \Never5\Aws\Result describeApps(array $args = [])
 * @method \GuzzleHttp\Promise\Promise describeAppsAsync(array $args = [])
 * @method \Never5\Aws\Result describeCommands(array $args = [])
 * @method \GuzzleHttp\Promise\Promise describeCommandsAsync(array $args = [])
 * @method \Never5\Aws\Result describeDeployments(array $args = [])
 * @method \GuzzleHttp\Promise\Promise describeDeploymentsAsync(array $args = [])
 * @method \Never5\Aws\Result describeEcsClusters(array $args = [])
 * @method \GuzzleHttp\Promise\Promise describeEcsClustersAsync(array $args = [])
 * @method \Never5\Aws\Result describeElasticIps(array $args = [])
 * @method \GuzzleHttp\Promise\Promise describeElasticIpsAsync(array $args = [])
 * @method \Never5\Aws\Result describeElasticLoadBalancers(array $args = [])
 * @method \GuzzleHttp\Promise\Promise describeElasticLoadBalancersAsync(array $args = [])
 * @method \Never5\Aws\Result describeInstances(array $args = [])
 * @method \GuzzleHttp\Promise\Promise describeInstancesAsync(array $args = [])
 * @method \Never5\Aws\Result describeLayers(array $args = [])
 * @method \GuzzleHttp\Promise\Promise describeLayersAsync(array $args = [])
 * @method \Never5\Aws\Result describeLoadBasedAutoScaling(array $args = [])
 * @method \GuzzleHttp\Promise\Promise describeLoadBasedAutoScalingAsync(array $args = [])
 * @method \Never5\Aws\Result describeMyUserProfile(array $args = [])
 * @method \GuzzleHttp\Promise\Promise describeMyUserProfileAsync(array $args = [])
 * @method \Never5\Aws\Result describePermissions(array $args = [])
 * @method \GuzzleHttp\Promise\Promise describePermissionsAsync(array $args = [])
 * @method \Never5\Aws\Result describeRaidArrays(array $args = [])
 * @method \GuzzleHttp\Promise\Promise describeRaidArraysAsync(array $args = [])
 * @method \Never5\Aws\Result describeRdsDbInstances(array $args = [])
 * @method \GuzzleHttp\Promise\Promise describeRdsDbInstancesAsync(array $args = [])
 * @method \Never5\Aws\Result describeServiceErrors(array $args = [])
 * @method \GuzzleHttp\Promise\Promise describeServiceErrorsAsync(array $args = [])
 * @method \Never5\Aws\Result describeStackProvisioningParameters(array $args = [])
 * @method \GuzzleHttp\Promise\Promise describeStackProvisioningParametersAsync(array $args = [])
 * @method \Never5\Aws\Result describeStackSummary(array $args = [])
 * @method \GuzzleHttp\Promise\Promise describeStackSummaryAsync(array $args = [])
 * @method \Never5\Aws\Result describeStacks(array $args = [])
 * @method \GuzzleHttp\Promise\Promise describeStacksAsync(array $args = [])
 * @method \Never5\Aws\Result describeTimeBasedAutoScaling(array $args = [])
 * @method \GuzzleHttp\Promise\Promise describeTimeBasedAutoScalingAsync(array $args = [])
 * @method \Never5\Aws\Result describeUserProfiles(array $args = [])
 * @method \GuzzleHttp\Promise\Promise describeUserProfilesAsync(array $args = [])
 * @method \Never5\Aws\Result describeVolumes(array $args = [])
 * @method \GuzzleHttp\Promise\Promise describeVolumesAsync(array $args = [])
 * @method \Never5\Aws\Result detachElasticLoadBalancer(array $args = [])
 * @method \GuzzleHttp\Promise\Promise detachElasticLoadBalancerAsync(array $args = [])
 * @method \Never5\Aws\Result disassociateElasticIp(array $args = [])
 * @method \GuzzleHttp\Promise\Promise disassociateElasticIpAsync(array $args = [])
 * @method \Never5\Aws\Result getHostnameSuggestion(array $args = [])
 * @method \GuzzleHttp\Promise\Promise getHostnameSuggestionAsync(array $args = [])
 * @method \Never5\Aws\Result grantAccess(array $args = [])
 * @method \GuzzleHttp\Promise\Promise grantAccessAsync(array $args = [])
 * @method \Never5\Aws\Result rebootInstance(array $args = [])
 * @method \GuzzleHttp\Promise\Promise rebootInstanceAsync(array $args = [])
 * @method \Never5\Aws\Result registerEcsCluster(array $args = [])
 * @method \GuzzleHttp\Promise\Promise registerEcsClusterAsync(array $args = [])
 * @method \Never5\Aws\Result registerElasticIp(array $args = [])
 * @method \GuzzleHttp\Promise\Promise registerElasticIpAsync(array $args = [])
 * @method \Never5\Aws\Result registerInstance(array $args = [])
 * @method \GuzzleHttp\Promise\Promise registerInstanceAsync(array $args = [])
 * @method \Never5\Aws\Result registerRdsDbInstance(array $args = [])
 * @method \GuzzleHttp\Promise\Promise registerRdsDbInstanceAsync(array $args = [])
 * @method \Never5\Aws\Result registerVolume(array $args = [])
 * @method \GuzzleHttp\Promise\Promise registerVolumeAsync(array $args = [])
 * @method \Never5\Aws\Result setLoadBasedAutoScaling(array $args = [])
 * @method \GuzzleHttp\Promise\Promise setLoadBasedAutoScalingAsync(array $args = [])
 * @method \Never5\Aws\Result setPermission(array $args = [])
 * @method \GuzzleHttp\Promise\Promise setPermissionAsync(array $args = [])
 * @method \Never5\Aws\Result setTimeBasedAutoScaling(array $args = [])
 * @method \GuzzleHttp\Promise\Promise setTimeBasedAutoScalingAsync(array $args = [])
 * @method \Never5\Aws\Result startInstance(array $args = [])
 * @method \GuzzleHttp\Promise\Promise startInstanceAsync(array $args = [])
 * @method \Never5\Aws\Result startStack(array $args = [])
 * @method \GuzzleHttp\Promise\Promise startStackAsync(array $args = [])
 * @method \Never5\Aws\Result stopInstance(array $args = [])
 * @method \GuzzleHttp\Promise\Promise stopInstanceAsync(array $args = [])
 * @method \Never5\Aws\Result stopStack(array $args = [])
 * @method \GuzzleHttp\Promise\Promise stopStackAsync(array $args = [])
 * @method \Never5\Aws\Result unassignInstance(array $args = [])
 * @method \GuzzleHttp\Promise\Promise unassignInstanceAsync(array $args = [])
 * @method \Never5\Aws\Result unassignVolume(array $args = [])
 * @method \GuzzleHttp\Promise\Promise unassignVolumeAsync(array $args = [])
 * @method \Never5\Aws\Result updateApp(array $args = [])
 * @method \GuzzleHttp\Promise\Promise updateAppAsync(array $args = [])
 * @method \Never5\Aws\Result updateElasticIp(array $args = [])
 * @method \GuzzleHttp\Promise\Promise updateElasticIpAsync(array $args = [])
 * @method \Never5\Aws\Result updateInstance(array $args = [])
 * @method \GuzzleHttp\Promise\Promise updateInstanceAsync(array $args = [])
 * @method \Never5\Aws\Result updateLayer(array $args = [])
 * @method \GuzzleHttp\Promise\Promise updateLayerAsync(array $args = [])
 * @method \Never5\Aws\Result updateMyUserProfile(array $args = [])
 * @method \GuzzleHttp\Promise\Promise updateMyUserProfileAsync(array $args = [])
 * @method \Never5\Aws\Result updateRdsDbInstance(array $args = [])
 * @method \GuzzleHttp\Promise\Promise updateRdsDbInstanceAsync(array $args = [])
 * @method \Never5\Aws\Result updateStack(array $args = [])
 * @method \GuzzleHttp\Promise\Promise updateStackAsync(array $args = [])
 * @method \Never5\Aws\Result updateUserProfile(array $args = [])
 * @method \GuzzleHttp\Promise\Promise updateUserProfileAsync(array $args = [])
 * @method \Never5\Aws\Result updateVolume(array $args = [])
 * @method \GuzzleHttp\Promise\Promise updateVolumeAsync(array $args = [])
 */
class OpsWorksClient extends AwsClient {}
