<?php
namespace Never5\Aws;

/**
 * Builds AWS clients based on configuration settings.
 *
 * @method \Never5\Aws\Acm\AcmClient createAcm(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionAcm(array $args = [])
 * @method \Never5\Aws\ApiGateway\ApiGatewayClient createApiGateway(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionApiGateway(array $args = [])
 * @method \Never5\Aws\ApplicationAutoScaling\ApplicationAutoScalingClient createApplicationAutoScaling(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionApplicationAutoScaling(array $args = [])
 * @method \Never5\Aws\ApplicationDiscoveryService\ApplicationDiscoveryServiceClient createApplicationDiscoveryService(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionApplicationDiscoveryService(array $args = [])
 * @method \Never5\Aws\Appstream\AppstreamClient createAppstream(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionAppstream(array $args = [])
 * @method \Never5\Aws\AutoScaling\AutoScalingClient createAutoScaling(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionAutoScaling(array $args = [])
 * @method \Never5\Aws\Batch\BatchClient createBatch(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionBatch(array $args = [])
 * @method \Never5\Aws\Budgets\BudgetsClient createBudgets(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionBudgets(array $args = [])
 * @method \Never5\Aws\CloudFormation\CloudFormationClient createCloudFormation(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionCloudFormation(array $args = [])
 * @method \Never5\Aws\CloudFront\CloudFrontClient createCloudFront(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionCloudFront(array $args = [])
 * @method \Never5\Aws\CloudHsm\CloudHsmClient createCloudHsm(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionCloudHsm(array $args = [])
 * @method \Never5\Aws\CloudSearch\CloudSearchClient createCloudSearch(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionCloudSearch(array $args = [])
 * @method \Never5\Aws\CloudSearchDomain\CloudSearchDomainClient createCloudSearchDomain(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionCloudSearchDomain(array $args = [])
 * @method \Never5\Aws\CloudTrail\CloudTrailClient createCloudTrail(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionCloudTrail(array $args = [])
 * @method \Never5\Aws\CloudWatch\CloudWatchClient createCloudWatch(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionCloudWatch(array $args = [])
 * @method \Never5\Aws\CloudWatchEvents\CloudWatchEventsClient createCloudWatchEvents(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionCloudWatchEvents(array $args = [])
 * @method \Never5\Aws\CloudWatchLogs\CloudWatchLogsClient createCloudWatchLogs(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionCloudWatchLogs(array $args = [])
 * @method \Never5\Aws\CodeBuild\CodeBuildClient createCodeBuild(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionCodeBuild(array $args = [])
 * @method \Never5\Aws\CodeCommit\CodeCommitClient createCodeCommit(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionCodeCommit(array $args = [])
 * @method \Never5\Aws\CodeDeploy\CodeDeployClient createCodeDeploy(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionCodeDeploy(array $args = [])
 * @method \Never5\Aws\CodePipeline\CodePipelineClient createCodePipeline(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionCodePipeline(array $args = [])
 * @method \Never5\Aws\CognitoIdentity\CognitoIdentityClient createCognitoIdentity(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionCognitoIdentity(array $args = [])
 * @method \Never5\Aws\CognitoIdentityProvider\CognitoIdentityProviderClient createCognitoIdentityProvider(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionCognitoIdentityProvider(array $args = [])
 * @method \Never5\Aws\CognitoSync\CognitoSyncClient createCognitoSync(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionCognitoSync(array $args = [])
 * @method \Never5\Aws\ConfigService\ConfigServiceClient createConfigService(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionConfigService(array $args = [])
 * @method \Never5\Aws\DataPipeline\DataPipelineClient createDataPipeline(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionDataPipeline(array $args = [])
 * @method \Never5\Aws\DatabaseMigrationService\DatabaseMigrationServiceClient createDatabaseMigrationService(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionDatabaseMigrationService(array $args = [])
 * @method \Never5\Aws\DeviceFarm\DeviceFarmClient createDeviceFarm(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionDeviceFarm(array $args = [])
 * @method \Never5\Aws\DirectConnect\DirectConnectClient createDirectConnect(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionDirectConnect(array $args = [])
 * @method \Never5\Aws\DirectoryService\DirectoryServiceClient createDirectoryService(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionDirectoryService(array $args = [])
 * @method \Never5\Aws\DynamoDb\DynamoDbClient createDynamoDb(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionDynamoDb(array $args = [])
 * @method \Never5\Aws\DynamoDbStreams\DynamoDbStreamsClient createDynamoDbStreams(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionDynamoDbStreams(array $args = [])
 * @method \Never5\Aws\Ec2\Ec2Client createEc2(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionEc2(array $args = [])
 * @method \Never5\Aws\Ecr\EcrClient createEcr(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionEcr(array $args = [])
 * @method \Never5\Aws\Ecs\EcsClient createEcs(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionEcs(array $args = [])
 * @method \Never5\Aws\Efs\EfsClient createEfs(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionEfs(array $args = [])
 * @method \Never5\Aws\ElastiCache\ElastiCacheClient createElastiCache(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionElastiCache(array $args = [])
 * @method \Never5\Aws\ElasticBeanstalk\ElasticBeanstalkClient createElasticBeanstalk(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionElasticBeanstalk(array $args = [])
 * @method \Never5\Aws\ElasticLoadBalancing\ElasticLoadBalancingClient createElasticLoadBalancing(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionElasticLoadBalancing(array $args = [])
 * @method \Never5\Aws\ElasticLoadBalancingV2\ElasticLoadBalancingV2Client createElasticLoadBalancingV2(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionElasticLoadBalancingV2(array $args = [])
 * @method \Never5\Aws\ElasticTranscoder\ElasticTranscoderClient createElasticTranscoder(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionElasticTranscoder(array $args = [])
 * @method \Never5\Aws\ElasticsearchService\ElasticsearchServiceClient createElasticsearchService(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionElasticsearchService(array $args = [])
 * @method \Never5\Aws\Emr\EmrClient createEmr(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionEmr(array $args = [])
 * @method \Never5\Aws\Firehose\FirehoseClient createFirehose(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionFirehose(array $args = [])
 * @method \Never5\Aws\GameLift\GameLiftClient createGameLift(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionGameLift(array $args = [])
 * @method \Never5\Aws\Glacier\GlacierClient createGlacier(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionGlacier(array $args = [])
 * @method \Never5\Aws\Health\HealthClient createHealth(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionHealth(array $args = [])
 * @method \Never5\Aws\Iam\IamClient createIam(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionIam(array $args = [])
 * @method \Never5\Aws\ImportExport\ImportExportClient createImportExport(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionImportExport(array $args = [])
 * @method \Never5\Aws\Inspector\InspectorClient createInspector(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionInspector(array $args = [])
 * @method \Never5\Aws\Iot\IotClient createIot(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionIot(array $args = [])
 * @method \Never5\Aws\IotDataPlane\IotDataPlaneClient createIotDataPlane(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionIotDataPlane(array $args = [])
 * @method \Never5\Aws\Kinesis\KinesisClient createKinesis(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionKinesis(array $args = [])
 * @method \Never5\Aws\KinesisAnalytics\KinesisAnalyticsClient createKinesisAnalytics(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionKinesisAnalytics(array $args = [])
 * @method \Never5\Aws\Kms\KmsClient createKms(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionKms(array $args = [])
 * @method \Never5\Aws\Lambda\LambdaClient createLambda(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionLambda(array $args = [])
 * @method \Never5\Aws\Lightsail\LightsailClient createLightsail(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionLightsail(array $args = [])
 * @method \Never5\Aws\MachineLearning\MachineLearningClient createMachineLearning(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionMachineLearning(array $args = [])
 * @method \Never5\Aws\MarketplaceCommerceAnalytics\MarketplaceCommerceAnalyticsClient createMarketplaceCommerceAnalytics(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionMarketplaceCommerceAnalytics(array $args = [])
 * @method \Never5\Aws\MarketplaceMetering\MarketplaceMeteringClient createMarketplaceMetering(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionMarketplaceMetering(array $args = [])
 * @method \Never5\Aws\OpsWorks\OpsWorksClient createOpsWorks(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionOpsWorks(array $args = [])
 * @method \Never5\Aws\OpsWorksCM\OpsWorksCMClient createOpsWorksCM(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionOpsWorksCM(array $args = [])
 * @method \Never5\Aws\Pinpoint\PinpointClient createPinpoint(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionPinpoint(array $args = [])
 * @method \Never5\Aws\Polly\PollyClient createPolly(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionPolly(array $args = [])
 * @method \Never5\Aws\Rds\RdsClient createRds(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionRds(array $args = [])
 * @method \Never5\Aws\Redshift\RedshiftClient createRedshift(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionRedshift(array $args = [])
 * @method \Never5\Aws\Rekognition\RekognitionClient createRekognition(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionRekognition(array $args = [])
 * @method \Never5\Aws\Route53\Route53Client createRoute53(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionRoute53(array $args = [])
 * @method \Never5\Aws\Route53Domains\Route53DomainsClient createRoute53Domains(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionRoute53Domains(array $args = [])
 * @method \Never5\Aws\S3\S3Client createS3(array $args = [])
 * @method \Never5\Aws\S3\S3MultiRegionClient createMultiRegionS3(array $args = [])
 * @method \Never5\Aws\ServiceCatalog\ServiceCatalogClient createServiceCatalog(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionServiceCatalog(array $args = [])
 * @method \Never5\Aws\Ses\SesClient createSes(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionSes(array $args = [])
 * @method \Never5\Aws\Sfn\SfnClient createSfn(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionSfn(array $args = [])
 * @method \Never5\Aws\Shield\ShieldClient createShield(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionShield(array $args = [])
 * @method \Never5\Aws\Sms\SmsClient createSms(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionSms(array $args = [])
 * @method \Never5\Aws\SnowBall\SnowBallClient createSnowBall(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionSnowBall(array $args = [])
 * @method \Never5\Aws\Sns\SnsClient createSns(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionSns(array $args = [])
 * @method \Never5\Aws\Sqs\SqsClient createSqs(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionSqs(array $args = [])
 * @method \Never5\Aws\Ssm\SsmClient createSsm(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionSsm(array $args = [])
 * @method \Never5\Aws\StorageGateway\StorageGatewayClient createStorageGateway(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionStorageGateway(array $args = [])
 * @method \Never5\Aws\Sts\StsClient createSts(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionSts(array $args = [])
 * @method \Never5\Aws\Support\SupportClient createSupport(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionSupport(array $args = [])
 * @method \Never5\Aws\Swf\SwfClient createSwf(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionSwf(array $args = [])
 * @method \Never5\Aws\Waf\WafClient createWaf(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionWaf(array $args = [])
 * @method \Never5\Aws\WafRegional\WafRegionalClient createWafRegional(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionWafRegional(array $args = [])
 * @method \Never5\Aws\WorkSpaces\WorkSpacesClient createWorkSpaces(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionWorkSpaces(array $args = [])
 * @method \Never5\Aws\XRay\XRayClient createXRay(array $args = [])
 * @method \Never5\Aws\MultiRegionClient createMultiRegionXRay(array $args = [])
 */
class Sdk
{
    const VERSION = '3.20.13';

    /** @var array Arguments for creating clients */
    private $args;

    /**
     * Constructs a new SDK object with an associative array of default
     * client settings.
     *
     * @param array $args
     *
     * @throws \InvalidArgumentException
     * @see Aws\AwsClient::__construct for a list of available options.
     */
    public function __construct(array $args = [])
    {
        $this->args = $args;

        if (!isset($args['handler']) && !isset($args['http_handler'])) {
            $this->args['http_handler'] = default_http_handler();
        }
    }

    public function __call($name, array $args)
    {
        $args = isset($args[0]) ? $args[0] : [];
        if (strpos($name, 'createMultiRegion') === 0) {
            return $this->createMultiRegionClient(substr($name, 17), $args);
        } elseif (strpos($name, 'create') === 0) {
            return $this->createClient(substr($name, 6), $args);
        }

        throw new \BadMethodCallException("Unknown method: {$name}.");
    }

    /**
     * Get a client by name using an array of constructor options.
     *
     * @param string $name Service name or namespace (e.g., DynamoDb, s3).
     * @param array  $args Arguments to configure the client.
     *
     * @return AwsClientInterface
     * @throws \InvalidArgumentException if any required options are missing or
     *                                   the service is not supported.
     * @see Aws\AwsClient::__construct for a list of available options for args.
     */
    public function createClient($name, array $args = [])
    {
        // Get information about the service from the manifest file.
        $service = manifest($name);
        $namespace = $service['namespace'];

        // Instantiate the client class.
        $client = "Aws\\{$namespace}\\{$namespace}Client";
        return new $client($this->mergeArgs($namespace, $service, $args));
    }

    public function createMultiRegionClient($name, array $args = [])
    {
        // Get information about the service from the manifest file.
        $service = manifest($name);
        $namespace = $service['namespace'];

        $klass = "Aws\\{$namespace}\\{$namespace}MultiRegionClient";
        $klass = class_exists($klass) ? $klass : 'Never5\Aws\\MultiRegionClient';

        return new $klass($this->mergeArgs($namespace, $service, $args));
    }

    private function mergeArgs($namespace, array $manifest, array $args = [])
    {
        // Merge provided args with stored, service-specific args.
        if (isset($this->args[$namespace])) {
            $args += $this->args[$namespace];
        }

        // Provide the endpoint prefix in the args.
        if (!isset($args['service'])) {
            $args['service'] = $manifest['endpoint'];
        }

        return $args + $this->args;
    }

    /**
     * Determine the endpoint prefix from a client namespace.
     *
     * @param string $name Namespace name
     *
     * @return string
     * @internal
     * @deprecated Use the `\Aws\manifest()` function instead.
     */
    public static function getEndpointPrefix($name)
    {
        return manifest($name)['endpoint'];
    }
}
