<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
} // Exit if accessed directly

class DLM_CA_Download_Option {

	/**
	 * Setup the class
	 */
	public function setup() {

		// Add option
		add_action( 'dlm_options_end', array( $this, 'add_download_option' ), 10, 1 );

		// Save download options
		add_action( 'dlm_save_metabox', array( $this, 'save_download_option' ), 10, 1 );

	}

	/**
	 * Add mail lock to download options
	 *
	 * @param $post_id
	 */
	public function add_download_option( $post_id ) {
		echo '<p class="form-field form-field-checkbox">
			<input type="checkbox" name="' . DLM_CA_Constants::META_CAPTCHA_LOCKED_KEY . '" id="' . DLM_CA_Constants::META_CAPTCHA_LOCKED_KEY . '" ' . checked( get_post_meta( $post_id, DLM_CA_Constants::META_CAPTCHA_LOCKED_KEY, true ), 'yes', false ) . ' />
			<label for="' . DLM_CA_Constants::META_CAPTCHA_LOCKED_KEY . '">' . __( 'Require Captcha', 'dlm-captcha' ) . '</label>
			<span class="dlm-description">' . __( 'User is required to complete a reCAPTCHA before access is granted to the dowload.', 'dlm-captcha' ) . '</span>
		</p>';
	}

	/**
	 * Save download option
	 *
	 * @param $post_id
	 */
	public function save_download_option( $post_id ) {
		$captcha = ( isset( $_POST[ DLM_CA_Constants::META_CAPTCHA_LOCKED_KEY ] ) ) ? 'yes' : 'no';
		if( 'yes' === $captcha ) {
			update_post_meta( $post_id, DLM_CA_Constants::META_CAPTCHA_LOCKED_KEY, $captcha );
		}else {
			delete_post_meta( $post_id, DLM_CA_Constants::META_CAPTCHA_LOCKED_KEY );
		}
	}

}
