<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
} // Exit if accessed directly

class DLM_EL_Download_Option {

	/**
	 * Setup the class
	 */
	public function setup() {

		// Add email locked download option
		add_action( 'dlm_options_end', array( $this, 'add_download_option' ), 10, 1 );

		// Save download options
		add_action( 'dlm_save_metabox', array( $this, 'save_download_option' ), 10, 1 );

	}

	/**
	 * Add mail lock to download options
	 *
	 * @param $post_id
	 */
	public function add_download_option( $post_id ) {
		echo '<p class="form-field form-field-checkbox">
			<input type="checkbox" name="' . DLM_EL_Constants::META_EMAIL_LOCKED_KEY . '" id="' . DLM_EL_Constants::META_EMAIL_LOCKED_KEY . '" ' . checked( get_post_meta( $post_id, DLM_EL_Constants::META_EMAIL_LOCKED_KEY, true ), 'yes', false ) . ' />
			<label for="' . DLM_EL_Constants::META_EMAIL_LOCKED_KEY . '">' . __( 'Email Lock', 'dlm-email-lock' ) . '</label>
			<span class="dlm-description">' . __( 'Email locked downloads will only be available after user entered their email address.', 'dlm-email-lock' ) . '</span>
		</p>';
	}

	/**
	 * Save download option
	 *
	 * @param $post_id
	 */
	public function save_download_option( $post_id ) {
		$email_locked = ( isset( $_POST[ DLM_EL_Constants::META_EMAIL_LOCKED_KEY ] ) ) ? 'yes' : 'no';
		if( 'yes' === $email_locked ) {
			update_post_meta( $post_id, DLM_EL_Constants::META_EMAIL_LOCKED_KEY, $email_locked );
		}else {
			delete_post_meta( $post_id, DLM_EL_Constants::META_EMAIL_LOCKED_KEY );
		}
	}

}