<?php

/**
 * Class DLM_EL_Export_All_Page
 *
 * Export all page, only used Download Monitor versions older than 4.0
 */
class DLM_EL_Export_All_Page {

	public function setup() {
		add_action( 'admin_menu', array( $this, 'admin_menu_export_all' ), 15 );
	}

	/**
	 * Add export all link
	 */
	public function admin_menu_export_all() {
		add_submenu_page( 'edit.php?post_type=dlm_download', __( 'Export All Email Lock', 'dlm-email-lock' ), __( 'Export All Email Lock', 'dlm-email-lock' ), 'manage_options', 'dlm-el-export-all', array(
			$this,
			'render'
		) );
	}

	public function render() {
		?>

		<div class="wrap dlm_extensions_wrap">
			<div class="icon32 icon32-posts-dlm_download" id="icon-edit"><br/></div>
			<h2>Download Monitor - <?php _e( 'Export All Email Lock Email Addresses', 'dlm-email-lock' ); ?></h2>
			<p>
				<a href="<?php echo admin_url( 'edit.php?post_type=dlm_download&page=dlm-el-export-all&dlm-el-export-csv=1&post-id=0' ); ?>"><?php _e( 'Click Here to Export All Email Addresses', 'dlm-email-lock' ); ?></a>
			</p>
		</div>
		<?php
	}

}