<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
} // Exit if accessed directly

class DLM_EL_Log_Manager {

	/**
	 * Setup class
	 */
	public function setup() {
		// Filter the download to redirect regular download buttons of mail locked downloads
		add_filter( 'dlm_log_item', array( $this, 'filter_log' ), 10, 3 );
	}

	/**
	 * Filter log item to add email address
	 *
	 * @param DLM_Log_Item $log_item
	 * @param DLM_Download $download
	 * @param DLM_Download_Version $version
	 *
	 * @return DLM_Log_Item $log_item
	 */
	public function filter_log( $log_item, $download, $version ) {

		/**
		 * if this set and we're at the point of filtering the log, the access manager accepted the download request,
		 * add email to download meta
		 */
		if ( isset( $_POST['dlm-email-lock-email'] ) && '' !== $_POST['dlm-email-lock-email'] && true == is_email( $_POST['dlm-email-lock-email'] ) ) {

			// add set email to log item
			$log_item->add_meta_data_item( 'el_email', sanitize_email( $_POST['dlm-email-lock-email'] ) );
		}

		return $log_item;
	}

}