<?php

/*
	Plugin Name: Download Monitor - Google Drive
	Plugin URI: https://www.download-monitor.com/
	Description: Lets you use the files hosted on your Google Drive as Download Monitor files.
	Version: 4.0.0
	Author: Never5
	Author URI: http://www.never5.com/
	License: GPL v3
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

class DLM_Google_Drive {

	const VERSION = '4.0.0';

	public function __construct() {

		// handler
		$handler = new DLM_GD_Handler();

		// catch Google Drive download request
		add_action( 'dlm_downloading', array( $handler, 'handle' ), 10, 3 );

		// Register Extension
		add_filter( 'dlm_extensions', array( $this, 'register_extension' ) );
	}

	/**
	 * Get the plugin file
	 *
	 * @static
	 *
	 * @return String
	 */
	public static function get_plugin_file() {
		return __FILE__;
	}

	/**
	 * Register this extension
	 *
	 * @param array $extensions
	 *
	 * @return array $extensions
	 */
	public function register_extension( $extensions ) {
		$extensions[] = array(
			'file'    => 'dlm-google-drive',
			'version' => self::VERSION,
			'name'    => 'Google Drive'
		);

		return $extensions;
	}

}

require_once dirname( __FILE__ ) . '/vendor/autoload_52.php';

function __dlm_google_drive() {
	new DLM_Google_Drive();
}

add_action( 'plugins_loaded', '__dlm_google_drive' );