<?php

/**
 * Optimised dependency check for Download Monitor - MailChimp Lock
 *
 * This file aims to check whether the required dependencies to run this plugin are installed. To use it, simply require the file
 * and store its return value in a variable.
 *
 * $can_run = require dirname( __FILE__ ) . '/dependency-check.php
 *
 */
defined( 'ABSPATH' ) or exit;

// check PHP version
if( version_compare( PHP_VERSION, '5.3', '<' ) ) {
	return false;
}

// check for MailChimp for WordPress v4.0
if( defined( 'MC4WP_VERSION' ) && version_compare( MC4WP_VERSION, '4.0', '>=' ) ) {
	return true;
}

// load required plugins notice class
require dirname( __FILE__ ) . '/src/class-required-plugins-notice.php';
$required_plugins = array(
	'mailchimp-for-wp' => array(
		'name' => 'MailChimp for WordPress',
		'url' => 'https://wordpress.org/plugins/mailchimp-for-wp/',
		'version' => '4.0',
	)
);
$notice = new MC4WP_Required_Plugins_Notice( 'Download Monitor - MailChimp Lock', $required_plugins );
$notice->add_hooks();

return false;
