<?php
/*
Plugin Name: Download Monitor - MailChimp Lock
Plugin URI: https://www.download-monitor.com/extensions/mailchimp-lock/
Description: Lock your downloads with a MailChimp for WordPress form.
Version: 1.2.1
Author: ibericode
Author URI: https://ibericode.com
Text Domain: dlm-mailchimp-lock
Domain Path: /languages
License: GPL v3

Download Monitor - MailChimp Lock
Copyright (C) 2015-2017, Danny van Kooten, hi@dannyvankooten.com

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

// Prevent direct file access
if ( ! defined( 'ABSPATH' ) ) {
	header( 'Status: 403 Forbidden' );
	header( 'HTTP/1.1 403 Forbidden' );
	exit;
}

function _load_dlm_mailchimp_lock() {

	// Check if PHP is at the minimum required version
	if( ! version_compare( PHP_VERSION, '5.3', '>=' ) ) {
		require_once dirname( __FILE__ ) . '/php-backwards-compatibility.php';
		return false;
	}

	// Check other dependencies
	$dependencies_met = require dirname( __FILE__ ) . '/dependency-check.php';
	if( ! $dependencies_met ) {
		return false;
	}

	define( 'DLM_MAILCHIMP_LOCK_FILE', __FILE__ );
	define( 'DLM_MAILCHIMP_LOCK_VERSION', '1.2.1' );

	// load bootstrap file
	require dirname( __FILE__ ) . '/bootstrap.php';
}

add_action( 'plugins_loaded', '_load_dlm_mailchimp_lock', 30 );
