<?php

defined( 'ABSPATH' ) or exit;

add_action( 'wp_loaded', 'dlm_mailchimp_set_cookie_from_request_url' );

// set cookie for every successful integration sign-up
add_action( 'mc4wp_integration_subscribed', function( $null, $email ) {
    dlm_mailchimp_set_cookie( $email );
}, 10, 2 );

// set cookie every time a form is submitted
add_action( 'mc4wp_form_respond', function( $form ) {
    dlm_mailchimp_set_cookie( $form->data['EMAIL'] );
}, 10, 2 );

// register extension slug for update checks
add_filter( 'dlm_extensions', function ( $extensions ) {
	$extensions[] = array(
		'file'    => 'dlm-mailchimp-lock',
		'version' => DLM_MAILCHIMP_LOCK_VERSION,
		'name'    => 'MailChimp Lock'
	);

	return $extensions;
} );

