<?php

defined( 'ABSPATH' ) or exit;

function dlm_mailchimp_set_cookie_from_request_url() {
	// don't if cookie already set
	if( ! empty( $_COOKIE['dlm_mailchimp_email'] ) ) {
		return;
	}

	// don't if url param empty or not given
	if( empty( $_GET['dlm_mailchimp_email'] ) ) {
		return;
	}

	dlm_mailchimp_set_cookie( $_GET['dlm_mailchimp_email'] );
}

/**
 * @param string $email
 */
function dlm_mailchimp_set_cookie( $email ) {
    $expiration_time = time() + ( DAY_IN_SECONDS * 7 );
    setcookie( 'dlm_mailchimp_email', $email, $expiration_time, '/' );
}

/**
 * @param DLM_Download $download
 *
 * @return bool
 */
function dlm_mailchimp_is_download_locked( $download ) {
    return $download->mailchimp_locked === 'yes';
}
