<?php if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Class NF_Action_SuccessMessage
 */
final class DLM_NF_Actions_Download_Link extends NF_Abstracts_Action {
	/**
	 * @var string
	 */
	protected $_name = 'dlm_link';

	/**
	 * @var array
	 */
	protected $_tags = array();

	/**
	 * @var string
	 */
	protected $_timing = 'late';

	/**
	 * @var int
	 */
	protected $_priority = 10;

	/**
	 * Constructor
	 */
	public function __construct() {
		parent::__construct();

		$this->_nicename = __( 'DLM Link', 'ninja-forms' );
	}

	/*
	* PUBLIC METHODS
	*/

	public function save( $action_settings ) {

	}

	public function process( $action_settings, $form_id, $data ) {

		if ( isset( $data['extra']['_download_id'] ) ) {
			$download_id = absint( $data['extra']['_download_id'] );

			try {
				$download = download_monitor()->service( 'download_repository' )->retrieve_single( $download_id );
			} catch ( Exception $exception ) {
				return $data;
			}

			// template handler
			$template_handler = new DLM_Template_Handler();

			ob_start();

			// load template
			$template_handler->get_template_part( 'nf-download-link', '', plugin_dir_path( DLM_Ninja_Forms::get_plugin_file() ) . 'templates/', array(
				'download' => $download
			) );

			$content = ob_get_clean();

			$data['actions']['success_message'] .= $content;

		}
		
		return $data;
	}

}
