<?php

/**
 * Class NF_Action_Redirect
 */
final class DLM_NF_Actions_Download_Redirect extends NF_Abstracts_Action {
	/**
	 * @var string
	 */
	protected $_name = 'dlm_redirect';

	/**
	 * @var array
	 */
	protected $_tags = array();

	/**
	 * @var string
	 */
	protected $_timing = 'late';

	/**
	 * @var int
	 */
	protected $_priority = 10;

	/**
	 * Constructor
	 */
	public function __construct() {
		parent::__construct();

		$this->_nicename = __( 'DLM Redirect', 'dlm-ninja-forms' );
	}

	public function save( $action_settings ) {

	}

	public function process( $action_settings, $form_id, $data ) {

		if ( isset( $data['extra']['_download_id'] ) ) {
			$download_id = absint( $data['extra']['_download_id'] );

			try {
				$download = download_monitor()->service( 'download_repository' )->retrieve_single( $download_id );
			} catch ( Exception $exception ) {
				return $data;
			}

			$data['actions']['redirect'] = $download->get_the_download_link();
		}

		return $data;
	}
}
