<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
} // Exit if accessed directly

class DLM_NF_Email_Action_Variables {

	/**
	 * Setup
	 */
	public function setup() {
		// replace Download Monitor template variables in email actions
		add_filter('ninja_forms_action_email_message', array( $this, 'replace_email_vars' ), 10, 3 );
	}

	public function replace_email_vars( $message, $data, $action_settings ) {

		// check if download_id is set
		if ( isset( $data['extra']['_download_id'] ) ) {

			// get downoad id
			$download_id = absint( $data['extra']['_download_id'] );

			// create download object
			try {
				/** @var DLM_Download $download */
				$download = download_monitor()->service( 'download_repository' )->retrieve_single( $download_id );
			} catch ( Exception $exception ) {
				return $message;
			}

			// replace vars
			$message = str_ireplace( "{dlm_download_id}", $download->get_id(), $message );
			$message = str_ireplace( "{dlm_download_title}", $download->get_title(), $message );
			$message = str_ireplace( "{dlm_download_url}", $download->get_the_download_link(), $message );
		}

		return $message;
	}

}
