<?php if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

final class DLM_NF_Form_Meta_box extends NF_Abstracts_SubmissionMetabox {

	public function __construct() {
		parent::__construct();
		$this->_title = __( 'Download', 'dlm-ninja-forms' );
		if ( $this->sub && ! $this->sub->get_extra_value( '_download_id' ) ) {
			remove_action( 'add_meta_boxes', array( $this, 'add_meta_boxes' ) );
		}
	}

	public function render_metabox( $post, $metabox ) {
		$download_id = $this->sub->get_extra_value( '_download_id' );
		if ( class_exists( 'DLM_Download' ) ) {

			try {
			    /** @var DLM_Download $download */
				$download = download_monitor()->service( 'download_repository' )->retrieve_single( $download_id );
			} catch ( Exception $exception ) {
				return;
			}

			$data = array(
				'ID'    => $download->get_id(),
				'Title' => $download->get_title()
			);

			if ( ! is_null( $download ) ) {
				?>
				<table cellspacing="0" cellpadding="0" border="0">
					<?php foreach ( $data as $k => $v ) : ?>
						<tr>
							<td style="font-weight: bold; padding: 5px 25px 5px 0;"><?php echo esc_html( $k ); ?></td>
							<td><?php echo esc_html( $v ); ?></td>
						</tr>
					<?php endforeach; ?>
					<tr>
						<td>&nbsp;</td>
						<td style="padding: 5px 0;"><a
								href="<?php echo admin_url( sprintf( 'post.php?post=%d&action=edit', $download->get_id() ) ); ?>"><?php _e( 'View Download', 'dlm-ninja-forms' ); ?></a>
						</td>
					</tr>
				</table>
				<?php
			}
		}
	}

}