<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
} // Exit if accessed directly

class DLM_NF_Ninja_Forms_Handler {

	/**
	 * Setup
	 */
	public function setup() {
		// Set entry id in cookie
		add_action( 'ninja_forms_after_submission', array( $this, 'set_entry_id_cookie' ) );
	}

	/**
	 * Set entry id in cookie
	 */
	public function set_entry_id_cookie( $form_data ) {

		if ( isset( $form_data['extra']['_download_id'] ) ) {
			$download_id = absint( $form_data['extra']['_download_id'] );
			$sub_id      = absint( $form_data['actions']['save']['sub_id'] );

			if ( $download_id > 0 ) {

				// Headers shouldn't be sent
				if ( ! headers_sent() ) {

					// Generate download hash
					$download_hash = md5( time() + mt_rand() + 'hallometad' );

					// Set meta
					update_post_meta( $sub_id, DLM_NF_Constants::META_SUB_DOWNLOAD_HASH, $download_hash );

					// Set the cookie
					setcookie( DLM_NF_Constants::COOKIE, json_encode( array(
						'sub_id'        => $sub_id,
						'form_id'       => absint( $form_data['form_id'] ),
						'download_id'   => $download_id,
						'download_hash' => $download_hash
					) ), apply_filters( 'dlm_nf_cookie_expire_time', 0, $download_id ), '/' );
				}

			}
		}

	}

}
