<?php

class DLM_NF_Shortcode {

	public function register() {
		// add dlm_nf_form shortcode
		add_shortcode( 'dlm_nf_form', array( $this, 'cb_dlm_nf_form' ) );
	}

	/**
	 * [dlm_nf_form] callback
	 *
	 * @param array $atts
	 *
	 * @return string
	 */
	public function cb_dlm_nf_form( $atts ) {

		// the download_id is a required attribute
		if ( ! isset( $atts['download_id'] ) ) {
			return 'Download Monitor - Ninja Forms Error: No download_id set!';
		}

		// default content
		$content = 'Download Monitor - Ninja Forms Error: Download is not Ninja Form locked!';

		// get form ID
		$form_id = get_post_meta( $atts['download_id'], DLM_NF_Constants::META_FORM, true );

		// check if exists
		if ( '' !== $form_id && 0 !== $form_id ) {

			// check if Ninja Forms function exists
			if ( class_exists( 'Ninja_Forms' ) ) {

				// Get Ninja Forms form
				ob_start();
				Ninja_Forms()->display( $form_id, false );
				$content = ob_get_clean();

				// extend NF form so we can add download ID dynamically
				$content .= str_replace( '%DOWNLOAD_ID%', $atts['download_id'], DLM_Ninja_Forms::get_nf_model_extend_js() );

			}
		}

		return $content;
	}

}