<?php

class DLM_NF_Settings {

	/**
	 * Add settings to DLM settings
	 *
	 * @param array $settings
	 *
	 * @return array
	 */
	public static function add_settings( $settings ) {

		$settings['ninja_forms'] = array(
			__( 'Ninja Forms', 'dlm-ninja-forms' ),
			array(
				array(
					'name'    => 'dlm_nf_unlock_type',
					'std'     => '',
					'label'   => __( 'Completing form will unlock', 'dlm-ninja-forms' ),
					'desc'    => __( 'Select what should be unlocked upon completing a form. Only applies to Ninja Forms locked downloads.', 'dlm-ninja-forms' ),
					'type'    => 'select',
					'options' => array(
						'per_download' => __( 'only requested download', 'dlm-ninja-forms' ),
						'per_form'     => __( 'all downloads with the same form', 'dlm-ninja-forms' ),
						'global'       => __( 'all locked downloads', 'dlm-ninja-forms' ),
					)
				),
			)
		);

		return $settings;
	}

}