<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
} // Exit if accessed directly

class DLM_TC_Options {

	/**
	 * Setup the class
	 */
	public function setup() {

		add_action( 'download_monitor_settings', array( $this, 'add_settings' ) );
	}

	/**
	 * Add Twitter Lock settings
	 *
	 * @param $settings
	 *
	 * @return mixed
	 */
	public function add_settings( $settings ) {
		$settings['terns_and_conditions'] = array(
			__( 'Terms & Conditions', 'dlm-twitter-lock' ),
			array(
				array(
					'name'  => 'dlm_tc_text',
					'std'   => __( 'I accept the terms & conditions', 'dlm-terms-and-conditions' ),
					'label' => __( 'Terms & Condition Text', 'dlm-terms-and-conditions' ),
					'desc'  => __( 'The text that visitors need to accept, is displayed next to the checkbox.', 'dlm-terms-and-conditions' ),
					'type'  => 'textarea'
				),
				array(
					'name'     => 'dlm_tc_global',
					'std'      => '',
					'cb_label' => __( 'All downloads require Terms & Conditions', 'dlm-terms-and-conditions' ),
					'label'    => __( 'All downloads require Terms & Conditions', 'dlm-terms-and-conditions' ),
					'desc'     => __( 'Require all of your downloads to have your terms & conditions checked.', 'dlm-terms-and-conditions' ),
					'type'     => 'checkbox'
				),
			)
		);

		return $settings;
	}

}