<?php

class DLM_TC_Shortcodes {

	/**
	 * Register shortcode(s)
	 */
	public function register() {
		add_shortcode( 'dlm_tc_form', array( $this, 'term_and_conditions_form' ) );
	}

	/**
	 * Tweet button shortcode
	 *
	 * @param array $atts
	 *
	 * @return string
	 */
	public function term_and_conditions_form( $atts ) {

		// check if download id is set
		if ( ! isset( $atts['id'] ) ) {
			return 'No <code>id</code> set';
		}

		// get download
		try {
			$download = download_monitor()->service( 'download_repository' )->retrieve_single( absint( $atts['id'] ) );

			// template handler
			$template_handler = new DLM_Template_Handler();

			// enqueue shrortcode JS
			DLM_TC_Assets::enqueue_shortcode_js();

			// unlock text
			$unlock_text = apply_filters( 'dlm_tc_unlock_text', get_option( 'dlm_tc_text', __( 'I accept the terms & conditions', 'dlm-terms-and-conditions' ) ), $download );

			// load template
			ob_start();
			$template_handler->get_template_part( 'tc-form', '', plugin_dir_path( DLM_Terms_And_Conditions::get_plugin_file() ) . 'templates/', array(
				'download'    => $download,
				'unlock_text' => $unlock_text
			) );

			return ob_get_clean();

		} catch ( Exception $exception ) {
			// no download with given ID found
		}

		return '';

	}

}