jQuery.fn.dlm_tweet_char_counter = function () {

    var counter = this;

    var tweet_input = this.parent().find( 'textarea:first' );

    tweet_input.keyup( function () {
        counter.removeClass( 'error' );
        counter.html( (140 - tweet_input.val().length) );
        if ( tweet_input.val().length > 140 ) {
            counter.addClass( 'error' );
        }
    } );

    this.addClass( 'dlm-tweet-counter' ).html( '140' );

    this.html( (140 - tweet_input.val().length) );

    return this;
};

jQuery.fn.dlm_tweet = function () {
    // create container
    var container = jQuery( '<div>' ).addClass( 'dlm_tweet_container' );

    // fetch parent
    var parent = this.parent();

    // append input field to container
    this.addClass( 'dlm-tweet-input' ).appendTo( container );

    // add char counter
    var counter = jQuery( '<span>' );
    counter.appendTo( container );

    // prepend container to original parent
    parent.prepend( container );

    // bang bang
    counter.dlm_tweet_char_counter();

    return this;
};

jQuery( document ).ready( function ( $ ) {

    if ( $( '#setting-dlm_tl_global_unlock_tweet' ).length > 0 ) {
        $( '#setting-dlm_tl_global_unlock_tweet' ).dlm_tweet();
    }

    if ( $( '#_dlm_tl_tweet_text' ).length > 0 ) {
        $( '#_dlm_tl_tweet_text' ).dlm_tweet();
    }

    $('#_dlm_tl_locked' ).change(function() {
        if($(this ).is(':checked')){
            $('.dlm-tl-tweet-input-wrap' ).addClass('dlm_tweet_container-active');
        }else {
            $('.dlm-tl-tweet-input-wrap' ).removeClass('dlm_tweet_container-active');
        }
    });

} );