<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
} // Exit if accessed directly

class DLM_TL_Access_Manager {

	/**
	 * Setup class
	 */
	public function setup() {
		// Filter the download to redirect regular download buttons of mail locked downloads
		add_filter( 'dlm_can_download', array( $this, 'check_access' ), 30, 3 );
	}

	/**
	 * Check if requester has access to download
	 *
	 * @param bool $has_access
	 * @param DLM_Download $download
	 * @param string $version
	 *
	 * @return bool
	 */
	public function check_access( $has_access, $download, $version ) {

		// Check if the Download is email locked
		$twitter_locked = get_post_meta( $download->get_id(), DLM_TL_Constants::META_TWITTER_LOCKED_KEY, true );
		if ( 'yes' !== $twitter_locked ) {
			return $has_access;
		}

		// try to tweet
		$twitter_handler = new DLM_TL_Twitter();

		// access to file is equal to the success of the tweet attempt
		$has_access = $twitter_handler->do_tweet( $download );

		return $has_access;
	}

}