<?php

class DLM_TL_Admin_Notices {

	/**
	 * Dem admin notices
	 */
	public static function notices() {

		// check if Download Monitor is installed
		if ( ! class_exists( 'WP_DLM' ) || ! defined( 'DLM_VERSION' ) || version_compare( DLM_VERSION, '4.0.0', '<' ) ) {
			?>
			<div class="error">
				<p><?php _e( 'Download Monitor 4.0.0 or higher needs to be activated for the Download Monitor - Twitter Lock extension!', 'dlm-twitter-lock' ); ?></p>
			</div>
			<?php
		}

		// get key & secret
		$key    = get_option( 'dlm_tl_consumer_key', '' );
		$secret = get_option( 'dlm_tl_consumer_secret', '' );

		// check
		if ( empty( $key ) || empty( $secret ) ) {
			?>
			<div class="error">
				<p><?php printf( __( 'Twitter Lock: No API key or API secret set! %sSetup API keys now%s', 'dlm-twitter-lock' ), '<a href="' . admin_url( 'edit.php?post_type=dlm_download&page=download-monitor-settings#settings-twitter_lock' ) . '">', '</a>' ); ?></p>
			</div>
			<?php
		}

	}

}