<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
} // Exit if accessed directly

class DLM_TL_Options {

	/**
	 * Setup the class
	 */
	public function setup() {

		add_action( 'download_monitor_settings', array( $this, 'add_settings' ) );
	}

	/**
	 * Add Twitter Lock settings
	 *
	 * @param $settings
	 *
	 * @return mixed
	 */
	public function add_settings( $settings ) {
		$settings['twitter_lock'] = array(
			__( 'Twitter Lock', 'dlm-twitter-lock' ),
			array(
				array(
					'name'  => 'dlm_tl_consumer_key',
					'std'   => '',
					'label' => __( 'Consumer Key (API Key)', 'dlm-twitter-lock' ),
					'desc'  => sprintf( __( 'The consumer key can be found in your %s. Select your App and click the "Keys and Access Tokens" tab.', 'dlm-twitter-lock' ), '<a href="https://apps.twitter.com/" target="_blank">Twitter apps dashboard</a>' ) .
					           '<br/>' . sprintf( __( 'Your application must have Read-Write access. %sRead our full app integration documentation.%s', 'dlm-twitter-lock' ), '<a href="https://www.download-monitor.com/kb/twitter-lock/" target="_blank">', '</a>' ),
					'type'  => 'text'
				),
				array(
					'name'  => 'dlm_tl_consumer_secret',
					'std'   => '',
					'label' => __( 'Consumer Secret (API Secret)', 'dlm-twitter-lock' ),
					'desc'  => sprintf( __( 'The consumer secret can be found in your %s. Select your App and click the "Keys and Access Tokens" tab.', 'dlm-twitter-lock' ), '<a href="https://apps.twitter.com/" target="_blank">Twitter apps dashboard</a>' ) .
					           '<br/>' . sprintf( __( 'Your application must have Read-Write access. %sRead our full app integration documentation.%s', 'dlm-twitter-lock' ), '<a href="https://www.download-monitor.com/kb/twitter-lock/" target="_blank">', '</a>' ),
					'type'  => 'text'
				),
				array(
					'name'  => 'dlm_tl_global_unlock_tweet',
					'std'   => '',
					'label' => __( 'Global Unlock Tweet', 'dlm-twitter-lock' ),
					'desc'  => __( 'The tweet text that will be tweeted if no download specific tweet is set.', 'dlm-twitter-lock'),
					'type'  => 'textarea'
				),
			)
		);

		return $settings;
	}

}