<?php

class DLM_TL_Shortcodes {

	/**
	 * Register shortcode(s)
	 */
	public function register() {
		add_shortcode( 'dlm_tl_tweet_button', array( $this, 'tweet_button' ) );
	}

	/**
	 * Tweet button shortcode
	 *
	 * @param array $atts
	 *
	 * @return string
	 */
	public function tweet_button( $atts ) {

		// check if download id is set
		if ( ! isset( $atts['id'] ) ) {
			return 'No <code>id</code> set';
		}

		try {
			$download = download_monitor()->service( 'download_repository' )->retrieve_single( absint( $atts['id'] ) );

			// template handler
			$template_handler = new DLM_Template_Handler();

			// enqueue shrortcode JS
			DLM_TL_Assets::enqueue_shortcode_js();

			// load template
			ob_start();
			$template_handler->get_template_part( 'tl-tweet-button', '', plugin_dir_path( DLM_Twitter_Lock::get_plugin_file() ) . 'templates/', array( 'download' => $download ) );

			return ob_get_clean();
		} catch ( Exception $exception ) {
			// no download found
		}

		return '';
	}

}